#!/usr/bin/python

import os, sys

from twisted.python import usage

class Options(usage.Options):
    optParameters = [
        ["country", "C", "US", None],
        ["state", "s", "New York", None],
        ["city", "c", "New York", None],
        ["organization", "o", "Divmod LLC", None],
        ["unit", "u", "Security", None],
        ["hostname", "h", "divmod.com", None],
        ["email", "e", "support@divmod.org", None]]

def createSSLCertificate(opts):
    w, r = os.popen2("/usr/bin/openssl req -x509 -newkey rsa:2048 -keyout server.pem -out server.pem -days 365 -nodes")
    for o in ('country', 'state', 'city', 'organization', 'unit', 'hostname', 'email'):
        w.write(opts[o] + '\n')
    w.flush()
    x = r.read()

def main(args=None):
    if args is None:
        args = sys.argv[1:]
    
    o = Options()
    try:
        o.parseOptions(args)
    except usage.UsageError, e:
        raise SystemExit(str(e))
    else:
        createSSLCertificate(o)

if __name__ == '__main__':
    main()
