# -*- test-case-name: atop.test.test_store -*-
# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

import types

class ItemForwardingComponent(object):
    def __init__(self, fwdTo):
        if hasattr(fwdTo, '__statecheck__'):
            raise RuntimeError("USE REFERENCETO!")
        self.fwdTo = fwdTo

    def __getattr__(self, attr):
        if attr[0] == '_':
            raise AttributeError
        else:
            def _(*a, **kw):
                return getattr(self.fwdTo.getItem(), attr)(*a, **kw)
            return _

    def __eq__(self, other):
        if not isinstance(other, ItemForwardingComponent):
            return False
        return self.fwdTo == other.fwdTo

_fwdCache = {}

def makeForwarder(state):
    if state not in _fwdCache:
        n = 'ForwardingComponent'
        b = (ItemForwardingComponent,)
        a = {'__implements__': state, '__reduce__': __reduce__}
        k = _fwdCache[state] = types.TypeType(n, b, a)
    return _fwdCache[state]

def makeForwarderInstance(implements, ref):
    return makeForwarder(implements)(ref)

def __reduce__(self):
    return makeForwarderInstance, (self.__implements__, self.fwdTo)
