# -*- test-case-name: quotient.test.test_peerup -*-
# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from atop import store
from atop import powerup

from twisted.python import components
from twisted.python import context

class IPeerUp(components.Interface):
    def allocateStoreID(self):
        pass

class PeerStoreup(powerup.Storeup):

    __implements__ = (IPeerUp,)

    def setUpPools(self, substore):
        self.touch()
        p = store.Pool(substore, name="peers")
        self.peerRef = p.referenceTo()
        substore.setComponent(IPeerUp, self)

    def allocateStoreID(self):
        L = self.getItemPath()
        L.append("remote.id")
        # XXX
        return store.updateIDKey(self.store.db, store.SEP.join(map(str, L)))

    def remoteItemByPath(self, *path):
        # Special case for local stuff
        pass
