from twisted.protocols.basic import LineReceiver
from twisted.internet import defer

class AstManager(LineReceiver):
    """Just does call origination for now. Possibly more exciting
    things later."""

    result = None
    version = None

    def __init__(self):
        self.dqueue = []
        
    def login(self, username, passwd):
        return self.execute(action="Login", username=username, secret=passwd)

    def originate(self, channel, extension, context):
        if '@' in channel:
            if channel.startswith('sip:'):
                channel = channel[4:]
            username, domain = channel.split('@',1)
            channel = "SIP/%s/%s" % (domain, username)
        elif channel.isdigit():
            channel = "Zap/g1/"+channel
        else:
            channel = "SIP/" + channel
        return self.execute(action="Originate",channel=channel,
                            exten=extension, context=context,
                            priority=1, callerid="Divmod <(301) 813-7823>")

    def execute(self, **kw):
        print kw
        for k, v in kw.iteritems():
            self.transport.write("%s: %s\r\n" % (k.capitalize(), v))
        self.transport.write('\r\n')
        d = defer.Deferred()
        self.dqueue.append(d)
        return d
    
    def lineReceived(self, line):
        line = line.strip()
        if not self.version:
            print "version"
            self.version = line
            return
        if self.result is None:
            self.result = {}
        if line:
            k, v = line.split(': ', 1)
            self.result[k] = v
        else:
            if self.result.has_key('Response'):
                d = self.dqueue.pop(0)
                if self.result['Response'] == 'Success':
                    d.callback(self.result['Message'])
                else:
                    d.errback(self.result['Message'])
                self.result = None
            elif self.result.has_key('Event'):
                # Someday we will figure out how to take advantage of events.
                pass
