# -*- test-case-name: quotient.test.test_extract -*-

# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.


from atop import store

from quotient.smarts import base

from twisted.python import components

def questionsFromText(text):
    questions = text.split('?')
    if len(questions) == 1:
        return
    byteOfft = 0
    for q in questions:
        if not q:
            continue
        begin = max(0, q.rfind('.'))
        while begin < len(q) and not (q[begin].isalpha() or q[begin].isdigit()):
            begin += 1
        begin += byteOfft
        byteOfft += len(q) + 1
        yield begin, byteOfft

class QuestionExtract(base.Textract):
    pass

class IQuestionPowerup(components.Interface):
    pass

class QuestionCollector(base.ExtractCollectorBase):
    """Pull questions out of newly received messages.
    """

    __implements__ = (IQuestionPowerup, base.ExtractCollectorBase.__implements__, store.IPipe,)

    powerupName = "Questions"

    ExtractType = QuestionExtract

    def setUpPools(self, avatar):
        base.ExtractCollectorBase.setUpPools(self, avatar)
        avatar.setComponent(IQuestionPowerup, self)

    def extractPart(self, item, text, part):
        i = 0
        for (begin, end) in questionsFromText(text):
            i += 1
            match = self.createExtract(text[begin:end], item, text, begin, end, part)
            self.foundExtract(item, match)
            if i > self.maxExtractsPer:
                return
