# -*- test-case-name: quotient.test.test_extract -*-

import re
from urlparse import urlparse

from atop import store

from twisted.python import components

from quotient.smarts import base

URL = re.compile(r'\w+://\S+', re.U)
def urlsFromText(s):
    for m in URL.finditer(s):
        yield m.start(), m.end()

class URLExtract(base.Textract):
    pass

class IURLPowerup(components.Interface):
    pass

class URLCollector(base.ExtractCollectorBase):
    """Pull URLs out of newly received messages.
    """

    __implements__ = (IURLPowerup, base.ExtractCollectorBase.__implements__, store.IPipe,)

    powerupName = "URLs"

    allowedSchemes = ('http', 'https', 'ftp')
    disallowedHosts = ('localhost', '127.0.0.1')

    ExtractType = URLExtract

    def setUpPools(self, avatar):
        base.ExtractCollectorBase.setUpPools(self, avatar)
        avatar.setComponent(IURLPowerup, self)

    def extractPart(self, item, text, part):
        s = text
        for (begin, end) in urlsFromText(text):
            url = s[begin:end]
            scheme, netloc, path, params, query, fragment = urlparse(url)
            if scheme not in self.allowedSchemes:
                continue
            if netloc in self.disallowedHosts:
                continue
            match = self.createExtract(url, item, text, begin, end, part)
            self.foundExtract(item, match)
