import time

from twisted.spread import pb
from twisted.python import log
from twisted.internet import task
from twisted.application import service

from quotient.web import functional
from quotient.web.functional import AuthData
from quotient.test import test_webui as twebui

from quotient.test.navtags import *


class InboxRenderBot(functional.TheOneTrueBaseClass, service.Service):
    numPagesToRetrieve = 1000
    
    def __init__(self, prt=80, d='divmod.com', u='', pwd=''):
        """constructor
        @param prt: port to connect on
        @param d: domain
        @param u: username
        @param pwd: password
        """
        self.port, self.domain, self.username, self.password = prt, d, u, pwd
        functional.TheOneTrueBaseClass.setUpClass(self)
        self.client.port = self.port
        self.client.domain = self.domain
        self.authData = AuthData(self.username, self.password)

    def getInboxRenderTime(self):
        starttime = time.time()
        self.runSeq(self.doSignin,
                    twebui.NO_TRACEBACK)

        inboxtime = time.time()
        self.runSeq(link('leftnav.Mail'))
        inboxtime = time.time() - inboxtime
        tottime = time.time() - starttime

        log.msg('rendertime: %s, inboxRetrieveTime: %s, responsetime: %s' % (self.page.renderTime, inboxtime, tottime))
        self.runSeq(twebui.LOGOUT)
        
    def startService(self):
        self.loopingCall = task.LoopingCall(self.getInboxRenderTime)
        self.loopingCall.start(3)

    def stopService(self):
        self.loopingCall.stop()
