
from os.path import join as opj

from atop.store import Store
from atop.credup import Avatar
from atop.powerup import IPowerStation
from atop.test import unittest
from atop.sched import SystemScheduler, IScheduler

from quotient.smarts import person
from quotient.mimemessage import EmailPowerup, IMIMEDelivery
from quotient.test import helper
from quotient import searchup

fromalice = [
'''From: alice@fooco.com
To: you
Subject: stuf!

This is a message from alice.
''',
'''From: "Alice Whatever" <alice@fooco.com>
To: "You!" <notalice@you>
Subject: YEs

This also a message from alice.
''']

notfromalice = [
'''From: alice@notfooco.com
To: you
Subject: NOT FROM ALICE.

This is not a message from alice.
''']


class PeopleTest(unittest.TestCase, helper.ProvisionerMixin):
    storePowerups = [SystemScheduler]

    def dbSetUp(self):
        a = self.jethro = self.createAvatar((EmailPowerup, person.PersonCollector))
        ppup = person.IPersonCollector(a)
        alice = self.alice = ppup.newPerson("Alice McExampleton")
        alice.setEmailAddress("alice@fooco.com", "work")
        alice.setPhoneNumber("123-456-7890", "work")
        alice.setEmailAddress("alice@mcexampleton.funkyisp.ny.us", "home")

    def dbTearDown(self):
        # nc = IScheduler(self.store).nextCall
        # nc and nc.cancel()
        nc = getattr(searchup.ISearch(self.jethro, default=None), 'checkpointDefer', None)
        nc and nc.cancel()

    def dbtestFindingContact(self):
        ppup = person.IPersonCollector(self.jethro)
        pepool = ppup.getPeoplePool()
        alice = pepool.queryIndex().next()
        md = IMIMEDelivery(self.jethro)
        for msgt in fromalice + notfromalice:
            mr = md.createMIMEReceiver(True)
            mr.feedStringNow(msgt)
        self.assertEquals(alice, self.alice)
        self.failIf(len(fromalice) > 100,
                    "You're getting carried away with example messages.")
        msgs = list(alice.recentMessages(100))
        self.assertEquals(len(fromalice), len(msgs))
    # dbtestFindingContact.skip = "Need to fix 'pendingTimedCalls still pending'"
