# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.


from nevow import tags
from formless import webform
from nevow import url
from nevow import inevow

from quotient.web import root
from quotient.web import pools
from quotient.taglib import *

class AccountConfiguration(root.Base):
    def render_switcher(self, context, data):
        current = context.locate(inevow.IRequest).args.get('view', [''])[0]
        views = [
            ('', 'View external accounts'),
            ('addPopGrabber', 'Add external POP3 account'),
            ('addIMAPGrabber', 'Add external IMAP4 account')]

        return tags.ul(_class="views")[[
            tags.li(_class=V == current and 'view-highlighted' or 'view-normal')[
                tags.a( href=url.here(view=V) )[ D ]
            ]
            for (V, D) in views
        ]]

    def render_current(self, context, data):
        current = context.locate(inevow.IRequest).args.get('view', [''])[0]
        if current:
            return webform.renderForms('',[current])
        pb = pools.PoolBrowser(self.original.grabbersRef.getItem())
        context.remember(pb, inevow.IRendererFactory)
        return pb

    document = page("External account configuration")[
        render_switcher,
        render_current,
    ]


class TabularGrabber(root.TabularBase):
    def render_foo(self, ctx, data): return 'foo'
