# filer.py

from time import time as now
from quotient.proto.mboxlist import listMailboxes, isAnEmailPool
from twisted.protocols import imap4


from atop import credup

from nevow.tags import *


def formatPoolList(L):
    return select(name="targetPool")[[
        option(value=str(name))[str(name)]
        for (name, pool) in L
    ]]


def gather(I):
    results = []
    for E in I:
        if isAnEmailPool(E[1]):
            results.append(E)
        yield None
    yield results


def mboxlist(context, data):
    ava = context.locate(credup.IAvatar)
    return imap4.iterateInReactor(gather(listMailboxes(ava.store, ava.getRootPool())))
