#!/usr/bin/python

import sys
import cPickle as pickle

from twisted.python import usage

from atop import store, credup

class Options(usage.Options):
    optParameters = [
        ["datadir", "d", "data/db", "Path to database directory"],
        ["filedir", "f", "data/files", "Path to auxillary file directory"],
        ["output", "o", "pools.pkl", "File to dumped pickled results to."]]

def poolsFromStore(st):
    for i in xrange(st.nextID(allocate=False)):
        try:
            o = st.getItemByID(i)
        except:
            pass
        else:
            if isinstance(o, store.Pool):
                yield o


def gatherPools(st):
    cc = credup.ICredentialsChecker(st)
    d = {(): [o.getItemPath() for o in st.transact(poolsFromStore, st)]}
    for a in st.transact(list, cc.getAvatars()):
        if tuple(a.getItemPath()) not in d:
            d[tuple(a.getItemPath())] = [o.getItemPath() for o in st.transact(poolsFromStore, a)]
    return d

def main(args=None):
    if args is None:
        args = sys.argv[1:]
    o = Options()
    try:
        o.parseOptions(args)
    except usage.UsageError, e:
        raise SystemExit(str(e))
    else:
        s = store.Store(o["datadir"], o["filedir"])
        try:
            pickle.dump(gatherPools(s), file(o["output"], "wb"))
        finally:
            s.close()

if __name__ == '__main__':
    main()
