#!/usr/bin/python

import sys
import cPickle as pickle

from twisted.python import usage

from atop import store

class Options(usage.Options):
    optParameters = [
        ["datadir", "d", "data/db", "Path to database directory"],
        ["filedir", "f", "data/files", "Path to auxillary file directory"],
        ["input", "o", "pools.pkl", "File to dumped pickled results to."]]

def determineDuplicates(st, pools):
    dupes = []
    for (k, v) in pools.iteritems():
        nameToItem = {}
        for itemPath in v:
            o = st
            for storeID in itemPath:
                o = o.getItemByID(storeID)
            if o.name is not None:
                nameToItem.setdefault(o.name.lower(), []).append(o)
        for (name, items) in nameToItem.iteritems():
            if len(items) > 1:
                dupes.append(items)
    return dupes

def displayDuplicates(itemGroups):
    for dupes in itemGroups:
        print '%r: %s' % (dupes[0].name, ' '.join([str(tuple(item.getItemPath())) for item in dupes]))


def main(args=None):
    if args is None:
        args = sys.argv[1:]
    o = Options()
    try:
        o.parseOptions(args)
    except usage.UsageError, e:
        raise SystemExit(str(e))
    else:
        s = store.Store(o["datadir"], o["filedir"])
        try:
            displayDuplicates(determineDuplicates(s, pickle.load(file(o["input"], "rb"))))
        finally:
            s.close()

if __name__ == '__main__':
    main()
