#!/usr/bin/env python2.3

import re, os
import os.path as osp
from os.path import join as opj

LOG_FILE = "/home/slyphon/Projects/DeployQuotient/twistd.log"
SUMMARY = "/tmp/traceback_summary.log"
NUM_ROTATIONS = 5

reEndTb = re.compile(r'^[^\t]')

def rotate():
    nums = range(5)
    if osp.exists(SUMMARY):
        # get rid of oldest log if it exists
        oldest = "%s.%d" % (SUMMARY, NUM_ROTATIONS - 1)
        if osp.exists(oldest):
            os.remove(oldest)

        # roll 'em back
        lastnum = 0
        for n in nums[::-1]:
            fname = "%s.%d" % (SUMMARY,n)
            if osp.exists(fname):
                os.rename(fname, "%s.%d" % (SUMMARY, n+1))

        # move latest to .0
        os.rename(SUMMARY, "%s.0" % SUMMARY)


def main():
    fp = file(LOG_FILE, 'r')
    result = []
    intb = False
    for line in fp:
        if intb and reEndTb.search(line):
            intb = False

        if not intb and 'Traceback' in line:
            intb = True

        if intb: result.append(line)

    rotate()
    file(SUMMARY, 'a').write(''.join(result))
    fp.close()


if __name__ == "__main__":
    main()
