#!/usr/bin/env python2.3
import sys, os, os.path as osp
from glob import glob
from shutil import copy as cp, move as mv
from os.path import join as opj, expanduser as xu, expandvars as xv, exists, isdir, islink, isfile
from os import unlink as rm, listdir as ls, chmod, mkdir, symlink, stat, environ as env, chdir as cd, getcwd
from popen2 import Popen4
from stat import S_ISLNK
import time


projects = xu('~/Projects')
spambayes = "spambayes-1.0a7"
spambayes_url = "http://www.divmod.org/users/slyphon/%s.tgz" % spambayes
local_lib = xu("~/lib/python2.3/site-packages")

repo = "svn+ssh://divmod.org/svn"
exponent = opj(repo, "Exponent")
lupy = opj(repo, "Lupy")
pyndex = opj(repo, 'Pyndex')
twisted = "svn+ssh://svn.twistedmatrix.com/svn/Twisted"
nevow = opj(repo,"Nevow")
reverend = opj(repo, "Reverend")


def cmd(astr):
    child = Popen4(astr)
    child.tochild.close()
    while 1:
        s = child.fromchild.read(1024)
        if not s:
            return
        sys.stdout.write(s)
        time.sleep(0.1)

def checkoutOrUpdate(url, dir):
    if not exists(dir):
        cmd("svn co %s %s" % (opj(url, 'trunk'), dir))
    else:
        cd(dir)
        print 'updating %s' % dir
        cmd('svn up')
        cd('..')

    if 'trunk' in dir:
        try:
            symlink('trunk', 'working')
        except OSError, e:
            print e

    
def pysetup(dir):
    print "cwd: %s" % getcwd()

    installed_dir = opj(local_lib, osp.basename(dir).lower())
    if exists(installed_dir):
        print 'removing previously installed copy at %s' % installed_dir
        cmd('rm -rf %s' % installed_dir)

    if 'Exponent' in dir:
        cmd('cp -a %s %s' % (opj(dir, 'exponent'), local_lib))
        return

    cd(dir)
    cmd('python2.3 setup.py install --prefix ~')
    cd('..')

    if exists('build'):
        cmd('rm -rf build')

def getSpambayes():
    sbdir = opj(projects, 'spambayes')
    if not exists(sbdir):
        cmd('wget %s' % spambayes_url)
        cmd('tar -zxvf %s.tgz' % spambayes)
        mv(spambayes, sbdir)
        rm('%s.tgz' % spambayes)
    pysetup(sbdir)
     

def main():
    if exists(projects) and not isdir(projects):
        print 'Projects exists and is not a directory, cannot continue'
        raise SystemExit(1)
    elif not exists(projects):
        mkdir(projects)

    for url, dir in [(exponent, 'Exponent'),
                     (lupy, 'Lupy'),
                     (pyndex, 'Pyndex'),
                     (twisted, 'Twisted/trunk'),
                     (nevow, 'Nevow/trunk'),
                     (reverend, 'Reverend')]:

        d = opj(projects, dir)
        checkoutOrUpdate(url, d)
        pysetup(d)
        
    getSpambayes()
    
    
if __name__ == '__main__':
    main()
