
import os

def runIn(dir, f, *a, **kw):
    cwd = os.getcwd()
    os.chdir(dir)
    try:
        return f(*a, **kw)
    finally:
        os.chdir(cwd)

def update():
    tag = raw_input('Base tag against which to update [HEAD]? ") or "HEAD"
    os.system("cvs up -A -r %s" % (tag,))
    try:
        while True:
            filename = raw_input("Filename to update? ")
            revision = raw_input("Revision [HEAD]? ") or "HEAD"
            os.system("cvs up -A -r %s %s" % (revision, filename))
    except KeyboardInterrupt:
        pass

def install():
    os.system("python2.3 setup.py install --prefix ~/")

def maybeGetData():
    datadir = os.path.join(os.environ['HOME'], 'data')
    delete = raw_input("Delete existing data directory (%s) [Y/n]? " % (datadir,))
    if delete.lower() not in ("", "y", "ye", "yes"):
        return

    shutil.rmtree(datadir)

    backups = os.listdir("/home/qbackup")
    while True:
        print '\n'.join(['%02d. %s' % (i, f) for (i, f) in enumerate(backups)])
        backup = raw_input("Select a backup: ")
        try:
            backup = int(backup)
        except ValueError:
            print 'Try again, dummy.'
        else:
            break
    
    shutil.copytree('/home/qbackup/%s' % backups[backup], './data')

def main():
    for proj in "Quotient", "Twisted", "Lupy":
        runIn(proj, update)
    for proj in "Quotient", "Twisted", "Lupy":
        runIn(proj, install)
    maybeGetData()

if __name__ == '__main__':
    main()
